package it.unimi.dsi.lama4j;

import static org.junit.Assert.assertEquals;

import org.junit.Test;

/*		 
 * LaMa4J: Lattice Manipulation for Java
 *
 * Copyright (C) 2006-2016 Marco Rosa and Sebastiano Vigna 
 *
 *  This library is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU Lesser General Public License as published by the Free
 *  Software Foundation; either version 2.1 of the License, or (at your option)
 *  any later version.
 *
 *  This library is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 *  or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License
 *  for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 */


public class ChainTest extends LaMa4JTestCase {

	@Test
	public void testNames() {
		Chain chain = new Chain( 5, "a", "b", "c" );

		assertLattice( chain );
		
		assertEquals( chain.valueOf( 0 ), chain.valueOf( "0" ) );
		assertEquals( chain.valueOf( 1 ), chain.valueOf( "a" ) );
		assertEquals( chain.valueOf( 2 ), chain.valueOf( "b" ) );
		assertEquals( chain.valueOf( 3 ), chain.valueOf( "c" ) );
		assertEquals( chain.valueOf( 4 ), chain.valueOf( "1" ) );
	}

	@Test
	public void testOperations0() {
		Lattice chain = new Chain( 3, "x" );

		assertLattice( chain );
		

		Element x = chain.valueOf( "x" );
		assertEquals( chain.meet( x ), x );
		assertEquals( chain.join( x ), x );
	}

	@Test
	public void testNoNames() {
		assertEquals( 3, new Chain( 3 ).elements().size() );
	}

	@Test
	public void testOperations1() {
		Chain chain = new Chain( 5 );

		assertLattice( chain );
		
		assertEquals( chain.valueOf( 1 ), chain.valueOf( 1 ).join( chain.valueOf( 0 ) ) );
		assertEquals( chain.valueOf( 0 ), chain.valueOf( 1 ).meet( chain.valueOf( 0 ) ) );
		assertEquals( chain.valueOf( 4 ), chain.one() );
		assertEquals( chain.valueOf( 0 ), chain.zero() );
	}
}
